# kern_descrip.c File Reference

`#include <sys/kern_descrip.h>`
`#include <ubixos/types.h>`
`#include <sys/sysproto.h>`
`#include <sys/thread.h>`
`#include <lib/kprintf.h>`
`#include <ubixos/endtask.h>`
`#include <lib/kmalloc.h>`
`#include <assert.h>`

Include dependency graph for kern_descrip.c:

Go to the source code of this file.

## Functions

int | close (struct thread *td, struct close_args *uap)
int | falloc (struct thread *td, struct file **resultfp, int *resultfd)
int | fcntl (struct thread *td, struct fcntl_args *uap)
int | fstat (struct thread *td, struct fstat_args *uap)
int | getdtablesize (struct thread *td, struct getdtablesize_args *uap)
| return data table size
int | getfd (struct thread *td, struct file **fp, int fd)
| get pointer to file fd in specified thread
int | ioctl (struct thread *td, struct ioctl_args *uap)
| ioctl functionality not implimented yet

## Function Documentation

int close | ( | struct thread * | td,
|  | struct close_args * | uap |
| ) |  |  |

Definition at line 90 of file kern_descrip.c.

References close_args::fd, kfree(), kprintf(), thread::o_files, and thread::td_retval.

Here is the call graph for this function:

int falloc | ( | struct thread * | td,
|  | struct file ** | resultfp,
|  | int * | resultfd |
| ) |  |  |

Definition at line 67 of file kern_descrip.c.

References kmalloc(), kprintf(), and thread::o_files.

Referenced by pipe(), and sys_open().

Here is the call graph for this function:

int fcntl | ( | struct thread * | td,
|  | struct fcntl_args * | uap |
| ) |  |  |

Definition at line 39 of file kern_descrip.c.

References fcntl_args::arg, fcntl_args::cmd, file::f_flag, FCNTLFLAGS, fcntl_args::fd, FFLAGS, kprintf(), O_ACCMODE, thread::o_files, and thread::td_retval.

Here is the call graph for this function:

int fstat | ( | struct thread * | td,
|  | struct fstat_args * | uap |
| ) |  |  |

Definition at line 112 of file kern_descrip.c.

References _current, fstat_args::fd, kprintf(), thread::o_files, fstat_args::sb, stat::st_blksize, stat::st_mode, taskStruct::td, and x1000.

Here is the call graph for this function:

int getdtablesize | ( | struct thread * | td,
|  | struct getdtablesize_args * | uap |
| ) |  |  |

return data table size

Definition at line 103 of file kern_descrip.c.

References kprintf(), O_FILES, and thread::td_retval.

Here is the call graph for this function:

int getfd | ( | struct thread * | td,
|  | struct file ** | fp,
|  | int | fd |
| ) |  |  |

get pointer to file fd in specified thread

Returns:
  returns fp

Definition at line 141 of file kern_descrip.c.

References kprintf(), and thread::o_files.

Referenced by read().

Here is the call graph for this function:

int ioctl | ( | struct thread * | td,
|  | struct ioctl_args * | uap |
| ) |  |  |

ioctl functionality not implimented yet

Returns:
  NULL for now

Definition at line 131 of file kern_descrip.c.

References thread::td_retval.